local aguf = {}

function aguf:Hook(module)
	if not aUF then return end
	if module ~= true and module ~= aUF then return end
	if not Deadened:IsHooked(aUF.units.aUFtarget, "SpellcastStart") then
		Deadened:Hook(aUF.units.aUFtarget, "SpellcastStart", aguf.UNIT_SPELLCAST_START, true)
	end
end

function aguf:Unhook(module)
	if not aUF then return end
	if module ~= true and module ~= aUF then return end
	if Deadened:IsHooked(aUF.units.aUFtarget, "SpellcastStart") then
		Deadened:Unhook(aUF.units.aUFtarget, "SpellcastStart")
	end
end

function aguf.UNIT_SPELLCAST_START(orig_object, event, unit, ...)
	if unit == "target" then
		local spell, rank, displayName, icon, startTime, endTime = UnitCastingInfo(unit)
		if not Deadened:NeedsSuppressing(displayName) then
			for k,v in pairs(Deadened.hooks[orig_object]) do
				v(orig_object, event, unit, ...)
			end
		else
			local spell, rank, displayName, icon, startTime, endTime = UnitCastingInfo(unit)
			Deadened:Alert(("%s casting %s (%s) sec"):format(UnitName(unit), displayName, ("%2.1f"):format((endTime-startTime) / 1000 )))
		end
	end
end

Deadened:AddHandler("ag_UnitFrames", aguf)
